#pragma once

#include <string>
#include <vector>

#include "msg.hpp"

#include "cf/network.h"
#include "cf/task.h"

typedef struct SConversation
{
	// tell and listen
	std::string sessid;
	std::string message;
	int sensitive;
	bool isError;

	// only for listen
	std::string from;
} SConversation;

class MessageQ
{
private:
	cf::task::mutex					mutex;
	std::vector<Protocol::Message>	messageQ;

public:
	void push(const Protocol::Message & parser);

	Protocol::Message pop(const std::string & requestType);
};

class chev
{
private:
	Protocol::Request	request;
	std::string			error;
	cf::network::tcp	socket;
	cf::task::thread	listener;

	MessageQ			messageQ;

	std::map<std::string, std::string>	sessionMap;

public:
	chev();

	~chev();

	const std::string & getLastError() const;

	bool connect(const std::string & host, unsigned short port);

	bool sms(const std::string & phone);

	bool join(const std::string & id, const std::string & pw, const std::string & sms);

	bool login(const std::string & id, const std::string & pw);

	bool addFriend(const std::string & id);

	std::vector<SFriend> getFriendList();

	std::string getSessionID(const std::vector<std::string> & idList);

	bool tell(const SConversation & conversation);

	SConversation listen();
};
